=== debian/changelog ===
toml11 (4.0.1-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * d/patches: Refresh cmake-install.patch, remove allow_tests.patch,
    and add patch to use external header file in tests
  * d/tests/toml: Remove test files that are not needed
  * d/copyright: Update copyright for removed test files
  * d/control: Replace libbost-test-dev with nlohmann-json3-dev and
    doctest-dev in Build-Depends for testing framework
  * d/tests/control: Replace libbost-test-dev with nlohmann-json3-dev
    and doctest-dev in Depends for testing framework and remove git
  * d/rules: Update variable name to build tests, remove undefined option,
    and remove copy for test files that have been removed
  * d/tests/run-unit-test: Update variable name to build tests, remove
    undefined option, and remove git specific option

 -- Lance Lin <lq27267@gmail.com>  Fri, 28 Jun 2024 19:13:50 +0700

toml11 (3.8.1-2) unstable; urgency=medium

  * d/control: Add libboost-test-dev to Build-Depends for running tests
  * d/patches: Refresh and add patch to allow tests to run during build
  * d/tests/toml: Include test files from external source that were being
    cloned during testing
  * d/copyright: Add copyright for included test files in debian/tests/toml
  * d/rules: Additional options for running the tests during build and copy
    test files from debian/tests/toml directory before dh_auto_configure

 -- Lance Lin <lq27267@gmail.com>  Thu, 07 Mar 2024 19:32:29 +0700
