## toml11 4.0.3

=== debian/changelog ===
toml11 (4.0.3-1) unstable; urgency=medium

  * New upstream version
  * d/patches: Refresh cmake-install.patch and
    include_doctest_from_external_dependency.patch.
  * d/patches: Add patch to downgrade uninitialized variable error
    to warning.
  * d/rules: Only build tests for amd64.

 -- Lance Lin <lq27267@gmail.com>  Thu, 18 Jul 2024 22:39:35 +0700
