=== debian/changelog ===
toml11 (4.1.0-1) unstable; urgency=medium

  * New upstream version
  * d/rules: Build tests for all architectures.
  * d/patches: Add patch to manually cast the file size to std::streamsize
    for 32-bit architectures.
  * d/patches: Extend cmake-install.patch to generate arch-independent
    cmake config files.

 -- Lance Lin <lq27267@gmail.com>  Mon, 05 Aug 2024 22:35:37 +0700
