## toml11 4.2.0

=== debian/changelog ===
toml11 (4.2.0-1) unstable; urgency=medium

  * New upstream version
  * d/patches: Remove patch applied upstream.

 -- Lance Lin <lq27267@gmail.com>  Thu, 22 Aug 2024 21:31:59 +0700
