=== debian/changelog ===
toml11 (4.4.0-1) unstable; urgency=medium

  * New upstream version
  * d/patches: Refresh patches.

 -- Lance Lin <lq27267@gmail.com>  Thu, 20 Feb 2025 20:17:25 +0700
