=== debian/tests/control ===
Tests: run-unit-test
Depends: @, cmake, build-essential, nlohmann-json3-dev, doctest-dev
Restrictions: allow-stderr
